

#include <htc.h>

#include "function.h"
#include <delays.h>             // library containing delays - i.e. wait for time 
#include <string.h>
//************  Dichiarazione VAriabili********************
const unsigned char Delimiter = 13;

extern unsigned char GSM_BUFF[20]; //declare receive buffer
extern unsigned char GSM_BUFF_URC[100]; //declare receive buffer
extern unsigned char GSM_BUFF_SIM[100];


extern const char AT_SIM_READ1[];
extern const char AT_SIM_READ2[];
extern const char AT_SIM_READ3[];
extern const char AT_SIM_READ4[];
extern const char AT_SIM_READ5[];
extern const char AT_SIM_READ6[];
extern const char AT_SIM_READ7[];
extern const char AT_SIM_READ8[];
extern const char AT_SIM_READ9[];
extern const char AT_SIM_READ10[];

//***************   CALL  AT COMMAND    ******************************

extern const char AT_CALL_CLOSE[]; /* Termina chiamata   */
extern unsigned char GSM_BUFF_SMS[];
extern unsigned char USER1[15];
extern unsigned char USER2[15];
extern unsigned char USER3[15];
extern unsigned char USER4[15];
extern unsigned char USER5[15];
extern unsigned char USER6[15];
extern unsigned char USER7[15];
extern unsigned char USER8[15];
extern unsigned char USER9[15];
extern unsigned char USER10[15];

//***************   SMS AT COMMAND    ******************************

const char AT_SMS_TEXT[] = "AT+CMGF=1\r"; // risposta SMS = TEXT  *
const char AT_SMS_DEL[] = "AT+CMGD=1\r"; // Canceslla SMS in posizione 1 della memoria *
const char AT_SMS_READ[] = "AT+CMGR=1\r"; // Legge SMS in posizione 1 della memoria

const char AT_SEND_SMS1[] = "AT+CMGS=\"+"; // risposta > deve segure messaggio di testo Ctrl+Z
const char AT_SEND_SMS2[] = "\"\r"; // prima bisogna mandare il N di telefono

//************** variable declaration
unsigned char SMS[] = "+CMTI";
unsigned char CALL[] = "+CLIP";
unsigned char GSM_SMS_SEND[] = "OUT: R1=X R2=X  IN: I0=X I1=X I2=X I3=X I4=X \r\n"; //declare receive buffer

extern unsigned int Utente1, Utente2, Utente3, Utente4, Utente5, Utente6, Utente7, Utente8, Utente9, Utente10;
extern unsigned int i, x, y, User, INT_AVVENUTO, URC_SMS, URC_CALL;
extern int Command_len, Relayout, User_len, input;
extern unsigned char SMS_char;




void USARTInit(unsigned long baudrate, unsigned char osc_freq_MHz) {
    unsigned int spbrg;

    TRISCbits.TRISC6 = 0; // set TX (RC6) as output
    TRISCbits.TRISC7 = 1; // and RX (RC7) as input

    // For a 16-bit sbprg value with USART_BRIGH_HIGH setting.
    // Formula from datasheet is Baudrate = FOSC/ (4 * (spbrg + 1 ))
    spbrg = (unsigned int) (((float) osc_freq_MHz * 1.0e6) / (4.0 * (float) baudrate) + 0.5 - 1.0);


    OpenUSART(USART_TX_INT_OFF & USART_RX_INT_OFF & USART_ASYNCH_MODE & USART_EIGHT_BIT &
            USART_CONT_RX & USART_BRGH_HIGH, spbrg);
    // OpenUSART is part of the C18 usart.h library

    BAUDCONbits.BRG16 = 1; // needed so we can use a 16-bit spbrg
    // Note that this is not discussed in the c18 Compiler Libraries guide
    Delay10KTCYx(1); // small 0.0125 s delay to allow communication speed to stabilize
    // part of the C18 delays.h library
}




//  STRING COMPARE

unsigned int Compare_string(unsigned char *SMS_message, unsigned char *Command) {

    unsigned char SMS_data, Command_data;
    i = 0; // contatore comando
    x = 0; // contatore SMS
    SMS_data = SMS_message[i]; // singolo carattere dell'SMS
    Command_data = Command[x]; // singolo carattere della stringa
    Command_len = strlen(Command); // lunghezza della stringa da cercare

    while (SMS_data != 0) { // verifica SMS e' finito
        if (x < Command_len) //
        { // se SMS non e' finito e contatore non  uguale alla lughezza del comando
            if (SMS_data == Command_data) x++; // se catattere SMS = crattere comando entra
            else x = 0;
        }

        i++;
        Command_data = Command[x];
        SMS_data = SMS_message[i];
    }

    if (x == Command_len) return 1; // Comando trovato nell'SMS
    else return 0; // Comando NON trovato nell'SMS

}



//Lettura USER abilitati dalla sim alla ram del PIC

void UserNumber(unsigned char *USERX) {

    unsigned char SIM_data = 35;
    User_len = strlen(GSM_BUFF_SIM); // verifico la lunghezza della stringa

    if (User_len > 15) // se > 15 utente presente in sim
    {
        i = 0; // puntatore a inizio numero
        x = 0; // puntatore ad arrey utente
        while (SIM_data != 34) { // copio numeri fono a " (34)
            SIM_data = GSM_BUFF_SIM[i];
            i++;
        }
        SIM_data = GSM_BUFF_SIM[i]; // trasferisco primo carattere
        while (SIM_data != 34) { // copio numeri fono a " (34)
            USERX[x] = SIM_data;
            i++;
            x++;
            SIM_data = GSM_BUFF_SIM[i];
        }
        USERX[x] = 0; // quando trovo " termino il vettore utente
    } else // se vettore < 15 nessun user nella sim
    {
        USERX[0] = 78; // messagio NO USER
        USERX[1] = 79;
        USERX[2] = 32;
        USERX[3] = 85;
        USERX[4] = 83;
        USERX[5] = 69;
        USERX[6] = 82;
        USERX[7] = 0;
    }
}

void WaitOneSecond(void) {
    Delay10KTCYx(200); // wait 10 000 * 200 * TCY = 0.250 seconds
    Delay10KTCYx(200); // Delay10KTCYx(num), num can only range from 1 to 255
    Delay10KTCYx(200);
    Delay10KTCYx(200);
}

void WaitHalfSecond(void) {
    Delay10KTCYx(200); // wait 10 000 * 200 * TCY = 0.250 seconds
    Delay10KTCYx(200); // Delay10KTCYx(num), num can only range from 1 to 255

}


//*  UART FUNCTION
void USART_Write_Line(const char *ln)
{
	Usart_Write_Text(ln);
	Usart_Write_Text("\r\n");
}
//*****************************************************
void Usart_Write_Text(const char *uart_text) {
    while ((*uart_text) != '\0') {
        //Wait for TXREG Buffer to become available
        while (!TXIF);
        //Write data
        TXREG = (*uart_text);
        //Next goto char
        uart_text++;
    }
}

//*****************************************************

void USART_Write_Int(int val, unsigned char field_length) {
    if (val < 0) {
        USART_Write_Byte('-'); //Write '-' sign for negative numbers.
        val = (val * (-1)); //Make it positive.
    }

    //Convert Number To String and pump over Tx Channel.
    char str[5] = {0, 0, 0, 0, 0};
    int i = 4, j = 0;
    while (val) {
        str[i] = val % 10;
        val = val / 10;
        i--;
    }
    if (field_length > 5)
        while (str[j] == 0) j++;
    else
        j = 5 - field_length;

    for (i = j; i < 5; i++) {
        USART_Write_Byte('0' + str[i]);
    }
}
//*****************************************************

void USART_Write_Byte(char ch) {
    //Wait for TXREG Buffer to become available
    while (!TXIF);

    //Write data
    TXREG = ch;
}
//*****************************************************

unsigned char ReadUSART() {
    return RCREG;
}

//*****************************************************

void Usart_Read_Text() {
    unsigned char Rx;
    int timeout;
    timeout = 0;
    Rx = 0;
    i = 0;
    while (1) {
        if (DataRdyUSART()) {
            Rx = ReadUSART();
            GSM_BUFF[i] = Rx;
            i++;
            break;
        }
    }

    while (timeout < 30000) {
        if (DataRdyUSART()) {
            Rx = ReadUSART();
            if (Rx == 13 || Rx == 10) {
                if (Rx == 10) {
                    GSM_BUFF[i] = 32;
                    i++;
                }
            } else {
                GSM_BUFF[i] = Rx;
                i++;
            }
            timeout = 0;
        }
        timeout++;
    }
    GSM_BUFF[i] = 0;
}
//************************************************

void Usart_Read_URC() {
    unsigned char Rxs;
    int timeout=0;
    timeout = 0;
    Rxs = 0;
    i = 0;

    while (timeout < 30000) {
        if (DataRdyUSART()) {
            Rxs = ReadUSART();
            GSM_BUFF_URC[i] = Rxs;
            i++;
            timeout = 0;
        }
        timeout++;
        if (i > 99) break;
    }
    GSM_BUFF_URC[i] = 0;
}
//**********************************************************

void Usart_Read_sms() {
    unsigned char Rxs;
    int timeout;
    timeout = 0;
    Rxs = 0;
    i = 0;
    while (1) {
        if (DataRdyUSART()) {
            Rxs = ReadUSART();
            GSM_BUFF_SMS[i] = Rxs;
            i++;
            break;
        }
    }

    while (timeout < 30000) {
        if (DataRdyUSART()) {
            Rxs = ReadUSART();
            GSM_BUFF_SMS[i] = Rxs;
            i++;
            timeout = 0;
        }
        timeout++;
    }
    GSM_BUFF_SMS[i] = 0;
}
//*******************************************************

void Usart_Read_SIM_User() {
    unsigned char Rxu;
    int timeout;
    timeout = 0;
    Rxu = 0;
    i = 0;
    while (1) {
        if (DataRdyUSART()) {
            Rxu = ReadUSART();
            GSM_BUFF_SIM[i] = Rxu;
            i++;
            break;
        }
    }

    while (timeout < 30000) {
        if (DataRdyUSART()) {
            Rxu = ReadUSART();
            GSM_BUFF_SIM[i] = Rxu;
            i++;
            timeout = 0;
        }
        timeout++;
    }
    GSM_BUFF_SIM[i] = 0;
}

void Load_User_SimToRam() {

    unsigned char SIM_data;

    // USER 1

    Usart_Write_Text(AT_SIM_READ1); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

        Usart_Write_Text("SIM 1 =");
        Usart_Write_Text(GSM_BUFF_SIM);
        USART_Write_Line(" ");
        
    UserNumber(USER1); // estraggo il numero e lo memorizzo in USER1
    Delay10KTCYx(1);


    //*******************************************************************************
    // USER 2


    Usart_Write_Text(AT_SIM_READ2); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER2); // estraggo il numero e lo memorizzo in USER2

    Delay10KTCYx(1); // Comando NON trovato nell'SMS

/*    //*******************************************************************************
    // USER 3

    Usart_Write_Text(AT_SIM_READ3); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER3); // estraggo il numero e lo memorizzo in USER3

    Delay10KTCYx(1);
    //*******************************************************************************
    // USER 4


    Usart_Write_Text(AT_SIM_READ4); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER4); // estraggo il numero e lo memorizzo in USER2

    Delay10KTCYx(1); // Comando NON trovato nell'SMS

    //*******************************************************************************
    // USER 5

    // PRINT OUT
    Usart_Write_Text(AT_SIM_READ5); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER5); // estraggo il numero e lo memorizzo in USER2
    // PRINT OUT the active numbe
    Delay10KTCYx(1); // Comando NON trovato nell'SMS

    //*******************************************************************************
    // USER 6

    // PRINT OUT
    Usart_Write_Text(AT_SIM_READ6); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER6); // estraggo il numero e lo memorizzo in USER2

    Delay10KTCYx(1); // Comando NON trovato nell'SMS

    //*******************************************************************************
    // USER 7

    // PRINT OUT
    Usart_Write_Text(AT_SIM_READ7); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER7); // estraggo il numero e lo memorizzo in USER2

    Delay10KTCYx(1); // Comando NON trovato nell'SMS

    //*******************************************************************************
    // USER 8
    // PRINT OUT
    Usart_Write_Text(AT_SIM_READ8); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER8); // estraggo il numero e lo memorizzo in USER2

    Delay10KTCYx(1); // Comando NON trovato nell'SMS

    //*******************************************************************************
    // USER 9

    // PRINT OUT
    Usart_Write_Text(AT_SIM_READ9); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER9); // estraggo il numero e lo memorizzo in USER2

    Delay10KTCYx(1); // Comando NON trovato nell'SMS

    //*******************************************************************************
    // USER 10

    // PRINT OUT
    Usart_Write_Text(AT_SIM_READ10); // send AT command for read user 1

    Usart_Read_SIM_User(); // read reply in

    UserNumber(USER10); // estraggo il numero e lo memorizzo in USER2

    Delay10KTCYx(1); // Comando NON trovato nell'SMS
*/
    //*******************************************************************************
}

void Int_from_UART(){

        Usart_Read_URC();
        Delay10KTCYx(10);
        Usart_Write_Text("URC_CALL =");
        Usart_Write_Text(GSM_BUFF_URC);
        USART_Write_Line(" ");

        URC_SMS = Compare_string(GSM_BUFF_URC, SMS);
        URC_CALL = Compare_string(GSM_BUFF_URC, CALL);

        if (URC_CALL == 1) { // entra se arriva una chiamata
            Usart_Write_Text(AT_CALL_CLOSE);
            // Close call
            Usart_Read_Text();

            Delay10KTCYx(50);

            User = 0;

            Utente1 = Compare_string(GSM_BUFF_URC, USER1); // verifico se SMS_sender e' contenuto nell'SMS
            //Usart_Write_Text("USER1 =");
            // Usart_Write_Text(USER1);
            //Usart_Write_Text(" Utente1 =");
            //USART_Write_Int(Utente1, 2);
            //USART_Write_Line(" ");
            Utente2 = Compare_string(GSM_BUFF_URC, USER2);

            Utente3 = Compare_string(GSM_BUFF_URC, USER3); // verifico se SMS_sender e' contenuto nell'SMS

            Utente4 = Compare_string(GSM_BUFF_URC, USER4);

            Utente5 = Compare_string(GSM_BUFF_URC, USER5); // verifico se SMS_sender e' contenuto nell'SMS

            Utente6 = Compare_string(GSM_BUFF_URC, USER6);

            Utente7 = Compare_string(GSM_BUFF_URC, USER7); // verifico se SMS_sender e' contenuto nell'SMS

            Utente8 = Compare_string(GSM_BUFF_URC, USER8);

            Utente9 = Compare_string(GSM_BUFF_URC, USER9); // verifico se SMS_sender e' contenuto nell'SMS

            Utente10 = Compare_string(GSM_BUFF_URC, USER10);

            if (Utente1 == 1) User = 1;
            if (Utente2 == 1) User = 2;
            if (Utente3 == 1) User = 3;
            if (Utente4 == 1) User = 4;
            if (Utente5 == 1) User = 5;
            if (Utente6 == 1) User = 6;
            if (Utente7 == 1) User = 7;
            if (Utente8 == 1) User = 8;
            if (Utente9 == 1) User = 9;
            if (Utente10 == 1) User = 10;

            if (User != 0) // Utente attivo
            {
                PORTCbits.RC4 = 1;
                WaitOneSecond();
                WaitOneSecond();
                PORTCbits.RC4 = 0;
            } else {

            }
        } // fine funzione di attivazione con squillo


        if (URC_SMS == 1) { // entra se arriva un SMS

            Usart_Write_Text(AT_SMS_READ); // send AT command Lettura SMS

            Usart_Read_sms();

                Usart_Write_Text("SMS: ");
                Usart_Write_Text(GSM_BUFF_SMS);
                USART_Write_Line(" ");

            User = 0;

            Utente1 = Compare_string(GSM_BUFF_SMS, USER1); // verifico se SMS_sender e' contenuto nell'SMS
            Utente2 = Compare_string(GSM_BUFF_SMS, USER2);
            Utente3 = Compare_string(GSM_BUFF_SMS, USER3); // verifico se SMS_sender e' contenuto nell'SMS
            Utente4 = Compare_string(GSM_BUFF_SMS, USER4);
            Utente5 = Compare_string(GSM_BUFF_SMS, USER5); // verifico se SMS_sender e' contenuto nell'SMS
            Utente6 = Compare_string(GSM_BUFF_SMS, USER6);
            Utente7 = Compare_string(GSM_BUFF_SMS, USER7); // verifico se SMS_sender e' contenuto nell'SMS
            Utente8 = Compare_string(GSM_BUFF_SMS, USER8);
            Utente9 = Compare_string(GSM_BUFF_SMS, USER9); // verifico se SMS_sender e' contenuto nell'SMS
            Utente10 = Compare_string(GSM_BUFF_SMS, USER10);


            if (Utente1 == 1) User = 1;
            if (Utente2 == 1) User = 2;
            if (Utente3 == 1) User = 3;
            if (Utente4 == 1) User = 4;
            if (Utente5 == 1) User = 5;
            if (Utente6 == 1) User = 6;
            if (Utente7 == 1) User = 7;
            if (Utente8 == 1) User = 8;
            if (Utente9 == 1) User = 9;
            if (Utente10 == 1) User = 10;


            if (User != 0) // Utente attivo
            {
                y = 0;
                SMS_char = GSM_BUFF_SMS[y];

                while (SMS_char != 0) {
                    if (SMS_char == 0x73 || SMS_char == 0x53) //se carattere  :"s" = 0x73  "S" = 0x53
                    {
                        y++;
                        SMS_char = GSM_BUFF_SMS[y];
                        if (SMS_char == 0) break;
                        switch (SMS_char) {
                            case 49: Relayout = Relayout | 1;
                                break; // if= 1 attiva out 1 (=1)
                            case 50: Relayout = Relayout | 2;
                                break; // if= 2 attiva out 2 (=1)
                            case 88: Relayout = Relayout | 3;
                                break; // if SX accendo tutti gli out
                            case 120: Relayout = Relayout | 3;
                                break; // if Sx accendo tutti gli out
                            default:
                                break;
                        }
                    }

                    if (SMS_char == 0x72 || SMS_char == 0x52) //se carattere  : "r" = 0x72  "R" = 0x52
                    {
                        y++;
                        SMS_char = GSM_BUFF_SMS[y];
                        if (SMS_char == 0) break; //legge carattere successivo
                        switch (SMS_char) {
                            case 49: Relayout = Relayout & 2;
                                break; // if =1 resetta  out 1 (=0)
                            case 50: Relayout = Relayout & 1;
                                break; // if =2 resetta  out 2 (=0)
                            case 88: Relayout = Relayout & 0;
                                break; // if RX spengo tutti gli out
                            case 120: Relayout = Relayout & 0;
                                break;  // if Rx spengo tutti gli out
                            default:
                                break;
                        }
                    }



                    if (SMS_char == 0x49 || SMS_char == 0x69) //se carattere  : "I" "i"
                    {
                        y++;
                        SMS_char = GSM_BUFF_SMS[y];
                        if (SMS_char == 0) break;
                        if (SMS_char == 0x6E || SMS_char == 0x4E) //se carattere  : "N" "n"
                        {
                            y++;
                            SMS_char = GSM_BUFF_SMS[y];
                            if (SMS_char == 0) break;
                            if (SMS_char == 0x45 || SMS_char == 0x74) //se carattere  : "T" "t"
                            {
                                y++;
                                SMS_char = GSM_BUFF_SMS[y];
                                if (SMS_char == 0x3F) //se carattere  : "?"
                                {
            Usart_Write_Text(" Relayout =");
            USART_Write_Int(Relayout, 2);
            USART_Write_Line(" ");


                                    //..................000000000011111111112222222222333333333344444444445
                                    //..................012345678901234567890123456789012345678901234567890
                                    //GSM_SMS_SEND[] = "OUT: R1=X R2=X  IN: I0=X I1=X I2=X I3=X I4=X \r\n"; declare receive buffer
                                   
                                    if ((Relayout & 1) == 1) GSM_SMS_SEND[8]= 0x31;                            // se il bit F0 di output= 1 scrivo 1 nell'SMS
                                        else GSM_SMS_SEND[8]= 0x30 ;                                     // se il bit F0 di output= 0 scrivo 0 nell'SMS

                                    if ((Relayout & 2) == 2) GSM_SMS_SEND[13]= 0x31;
                                        else GSM_SMS_SEND[13]= 0x30 ;

                                    // INGRESSI
                                    if (PORTBbits.RB0 == 0) GSM_SMS_SEND[23]= 0x30;
                                        else GSM_SMS_SEND[23]= 0x31 ;

                                    if (PORTBbits.RB1 == 0) GSM_SMS_SEND[28]= 0x30;
                                        else GSM_SMS_SEND[28]= 0x31 ;

                                    if (PORTBbits.RB2 == 0) GSM_SMS_SEND[33]= 0x30;
                                        else GSM_SMS_SEND[33]= 0x31 ;
                                    
                                    if (PORTBbits.RB3 == 0) GSM_SMS_SEND[38]= 0x30;
                                        else GSM_SMS_SEND[38]= 0x31 ;

                                    if (PORTBbits.RB4 == 0) GSM_SMS_SEND[43]= 0x30;
                                        else GSM_SMS_SEND[43]= 0x31 ;

                                    // mettere lettura ingressi ....



                                    // AT_SEND_SMS1 = "AT+CMGS=\"+";                                  // risposta > deve segure messaggio di testo Ctrl+Z
                                    // AT_SEND_SMS2 = "\"\r";                                         // prima bisogna mandare il N di telefono
                                    // GSM_CTRL_Z = 0x1A;                                             // 26  for cnrlZ  per chiudere SMS



                                    Usart_Write_Text(AT_SEND_SMS1); // send AT command invio  SMS

                                    switch (User) { // invia in N di telefono dell'utente richiedente
                                        case 1: Usart_Write_Text(USER1);
                                            break; // user 1
                                        case 2: Usart_Write_Text(USER2);
                                            break; // user 2
                                        case 3: Usart_Write_Text(USER3);
                                            break;
                                        case 4: Usart_Write_Text(USER4);
                                            break;
                                        case 5: Usart_Write_Text(USER5);
                                            break;
                                        case 6: Usart_Write_Text(USER6);
                                            break;
                                        case 7: Usart_Write_Text(USER7);
                                            break;
                                        case 8: Usart_Write_Text(USER8);
                                            break;
                                        case 9: Usart_Write_Text(USER9);
                                            break;
                                        case 10: Usart_Write_Text(USER10);
                                            break;
                                        default:
                                            break;
                                    }

                                    Usart_Write_Text(AT_SEND_SMS2); // invia chiusura SMS

                                    Usart_Read_Text(); // si aspetta > prima di inviare il testo dell'SMS

                                    Usart_Write_Text(GSM_SMS_SEND); // invia i caratteri dell'SMS
                                    USART_Write_Byte(GSM_CTRL_Z); // invia chiusura SMS
                                    USART_Write_Byte(GSM_ENTER); // invia chiusura SMS

                                }
                            }
                        }
                    }
                    if (SMS_char == 0) break;
                    y++;
                    SMS_char = GSM_BUFF_SMS[y];
                }

                // stampa sul diplay valore decimale dell'out
 
                switch (Relayout) {
                    case 0: PORTCbits.RC4 = 0;
                            PORTCbits.RC5 = 0;
                        break;
                    case 1: PORTCbits.RC4 = 1;
                            PORTCbits.RC5 = 0;
                        break;
                    case 2: PORTCbits.RC4 = 0;
                            PORTCbits.RC5 = 1;
                        break;
                    case 3: PORTCbits.RC4 = 1;
                            PORTCbits.RC5 = 1;
                        break;
                    default:
                        break;
                        }
            }
        }

}

